if select(3, UnitClass("player")) ~= 9 then return end -- Only load when playing a warlock
Whipped = LibStub("AceAddon-3.0"):NewAddon("Whipped", "AceConsole-3.0", "AceEvent-3.0")
local Whipped = _G.Whipped

--Setup
local WHIPPED_CHAT_FONT = "Interface\\AddOns\\Whipped\\Fonts\\monofonto.ttf"
Whipped.anchors = {"LEFT","RIGHT","TOP","BOTTOM"}
Whipped.strata = {"BACKGROUND", "LOW", "MEDIUM", "HIGH", "DIALOG", "FULLSCREEN", "FULLSCREEN_DIALOG", "TOOLTIP"}
local TimeSinceLastUpdate = 0
local Whipped_UpdateInterval = .05 -- How often the OnUpdate code will run (in seconds)
local mfloor, tinsert, sformat = math.floor, table.insert, string.format -- DEBUG: sformat
local ScreenWidth, ScreenHeight = mfloor(GetScreenWidth()+.5), mfloor(GetScreenHeight()+.5)
local COMBATLOG_OBJECT_AFFILIATION_MINE = COMBATLOG_OBJECT_AFFILIATION_MINE
local Demons
Whipped.Demons = {
	ActiveDemons =
		function()
			return Demons.BaseDemon.Alive + Demons.Imps.Alive() + Demons.Dreadstalkers.Alive + Demons.CooldownDemon.Alive + Demons.GrimoireDemon.Alive + Demons.Darkglare.Alive
		end,
	BaseDemon = {
		Alive = 0,
		Type = 0,
		GUID = 0,
		DE = 1,
		Health =
			function()
				if Whipped.Demons.BaseDemon.Type == 157757 then -- Doomguard has less hp than the others
					return UnitHealthMax("player") * .4 * Demons.BaseDemon.DE * Demons.BaseDemon.Alive
				else
					return UnitHealthMax("player") * .5 * Demons.BaseDemon.DE * Demons.BaseDemon.Alive
				end
			end,
		Name = "NoName"
	},
	Imps = {
		Alive =
			function()
				local Imps,c = Whipped.Demons.Imps, 0
				for i=1,Whipped.ImpFrameListSize do
					c = c + Imps.HoG.Wave[i].IPW
				end
				c = c + Imps.Dreadstalkers.IPW
				for k,v in pairs(Imps.Doom.Wave) do
					c = c + v.IPW
				end
				return c
			end,
		Health = -- Get the combined hp of all your active imps
			function()
				local c, BaseImpHp = 0, UnitHealthMax("player") * 3 / 20
				for i=1,Whipped.ImpFrameListSize do
					c = c + BaseImpHp * Demons.Imps.HoG.Wave[i].DE * Demons.Imps.HoG.Wave[i].IPW
				end
					c = c + BaseImpHp * Demons.Imps.Dreadstalkers.DE * Demons.Imps.Dreadstalkers.IPW
				for k,v in pairs(Demons.Imps.Doom.Wave) do
					c = c + BaseImpHp * v.DE * v.IPW
				end
				return c
			end,
		HoG = {
			Batch = true,
			IICB = 0,
			Wave = {
				[1] = {
					Summoned = false, -- Used for nothing more than skipping entries in a loop in OnUpdate
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[2] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[3] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[4] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[5] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[6] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[7] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[8] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[9] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[10] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[11] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[12] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				},
				[13] = {
					Summoned = false,
					DE = 1,
					TTL = 0,
					Dead = 0,
					IPW = 0, -- Imps Per Wave
					GUID = {}
				}
			}
		},
		Dreadstalkers = {
			Batch = true,
			DE = 1,
			IICB = 0,
			IPW = 0, -- Imps in current batch
			--TTL: Timer is handled in Whipped_Dreadstalkers
			Dead = 0,
			GUID1 = 0,
			GUID2 = 0
		},
		Doom = {
			Batch = true,
			DE = 1,
			IICB = 0, -- Imps in current batch
			CurrentWave = 0,
			Wave = {} -- TTL, IPW, Dead, WaveNum, GUID
		}
	},
	Dreadstalkers = {
		Summoned = false,
		Alive = 0,
		CD = 0,
		TTL = 0,
		DE = 1,
		Dead = 0,
		Health = -- Get the combined hp of your active dreadstalkers
			function()
				return UnitHealthMax("player") * .4 * Demons.Dreadstalkers.DE * Demons.Dreadstalkers.Alive
			end,
		GUID1 = 0,
		GUID2 = 0
	},
	CooldownDemon = {
		Summoned = false,
		Alive = 0,
		CD = 0,
		TTL = 0,
		DE = 1,
		Name = "NoName",
		Health =
			function()
				return UnitHealthMax("player") * .4 * Demons.CooldownDemon.DE * Demons.CooldownDemon.Alive
			end,
		GUID = 0
	},
	GrimoireDemon = {
		Summoned = false,
		Talented = false,
		Alive = 0,
		CD = 0,
		TTL = 0,
		DE = 1,
		Name = "NoName",
		Health =
			function()
				return UnitHealthMax("player") * .5 * Demons.GrimoireDemon.DE * Demons.GrimoireDemon.Alive
			end,
		GUID = 0
	},
	Darkglare = {
		Summoned = false,
		Talented = false,
		Alive = 0,
		CD = 0,
		TTL = 0,
		DE = 1,
		Health =
			function()
				return UnitHealthMax("player") * .4 * Demons.Darkglare.DE * Demons.Darkglare.Alive
			end,
		GUID = 0,
	}
}
Demons = Whipped.Demons
local DOOM, DoomTimer = {}, 0
local DE, UpdateFonts, DE_DamageIncrease = 0, -1, 1.5 -- Demonic Empowerment
local UNIT_PET_UPDATE = true -- Make sure the event only fires one bloody time each time your pet spawns or goes away

-- Frames
Whipped.MasterFrame = CreateFrame("FRAME",nil, UIParent) -- The frame all other stuff should stick to
local Frame_Artefact_Icon = CreateFrame("FRAME", nil, Whipped.MasterFrame)
local Frame_Demonbolt_Icon = CreateFrame("FRAME", nil, Whipped.MasterFrame)
local Frame_Doom_Icon = CreateFrame("FRAME", nil, Whipped.MasterFrame)
local Frame_Implosion_Icon = CreateFrame("FRAME", nil, Whipped.MasterFrame)
local Frame_MainDemon_Icon = CreateFrame("FRAME", nil, Whipped.MasterFrame)
local FontString_Artefact = Frame_Artefact_Icon:CreateFontString()
local FontString_Demonbolt = Frame_Demonbolt_Icon:CreateFontString()
local FontString_Doom = Frame_Doom_Icon:CreateFontString()
local FontString_Implosion = Frame_Implosion_Icon:CreateFontString()

--DB and Options
local defaults = {
	global = {
		Show = true,
		Locked = false,
		ShowOOC = false, -- Out of Combat
		X = 400,
		Y = 400,
		PaddingX = 2,
		PaddingY = 2,
		Anchor = 1,
		Strata = "BACKGROUND",
		Icons = {
			Artefact_Size = 48,
			Artefact_X = 0,
			Artefact_Y = 0,
			Artefact_AnchorFrame = Whipped.MasterFrame,
			Artefact_AnchorPoint = 1,
			Artefact_NumberAnchorPoint = 1,
			Doom_Size = 48,
			Doom_AnchorFrame = Whipped.MasterFrame,
			Doom_AnchorPoint = 1,
			Doom_NumberAnchorPoint = 1,
			Doom_X = 0,
			Doom_Y = 0,
			DoomPartials = true,
			Demonbolt_Size = 48,
			Demonbolt_X = 0,
			Demonbolt_Y = 0,
			Demonbolt_AnchorFrame = Whipped.MasterFrame,
			Demonbolt_AnchorPoint = 1,
			Demonbolt_NumberAnchorPoint = 1,
			Implosion_Size = 48,
			Implosion_AnchorFrame = Whipped.MasterFrame,
			Implosion_AnchorPoint = 1,
			Implosion_NumberAnchorPoint = 1,
			Implosion_X = 0,
			Implosion_Y = 0
		},
		SoulShards = {
			Width = 10,
			Height = 40,
			Padding = 2,
			Show = true,
			Color = {
				r = 1,
				g = 0,
				b = 1,
				a = 1
			}
		},
		Imps = {
			Thickness = 20,
			Padding = 2,
			Show = true,
			Color_1 = {
				r = 0,
				g = 1,
				b = 0,
				a = 1
			},
			Color_2 = {
				r = 0,
				g = .6,
				b = 0,
				a = 1
			},
			Color_Empowered_1 = {
				r = 1,
				g = 0,
				b = 0,
				a = 1
			},
			Color_Empowered_2 = {
				r = .9,
				g = .3,
				b = .3,
				a = 1
			}
		},
		Dreadstalkers = {
			Thickness = 20,
			Padding = 2,
			Show = true,
			Color = {
				r = 0,
				g = 1,
				b = 0,
				a = 1
			},
			Color_Empowered = {
				r = 1,
				g = 0,
				b = 0,
				a = 1
			},
			Color_Cooldown = {
				r = 0,
				g = 0,
				b = 1,
				a = 1
			}
		},
		Cooldown = {
			Thickness = 20,
			Padding = 2,
			Show = true,
			Color = {
				r = 0,
				g = 1,
				b = 0,
				a = 1
			},
			Color_Empowered = {
				r = 1,
				g = 0,
				b = 0,
				a = 1
			},
			Color_Cooldown = {
				r = 0,
				g = 0,
				b = 1,
				a = 1
			}
		},
		Grimoire = {
			Thickness = 20,
			Padding = 2,
			Show = true,
			Color = {
				r = 0,
				g = 1,
				b = 0,
				a = 1
			},
			Color_Empowered = {
				r = 1,
				g = 0,
				b = 0,
				a = 1
			},
			Color_Cooldown = {
				r = 0,
				g = 0,
				b = 1,
				a = 1
			}
		},
		Darkglare = {
			Thickness = 20,
			Padding = 2,
			Show = true,
			Color = {
				r = 0,
				g = 1,
				b = 0,
				a = 1
			},
			Color_Empowered = {
				r = 1,
				g = 0,
				b = 0,
				a = 1
			},
			Color_Cooldown = {
				r = 0,
				g = 0,
				b = 1,
				a = 1
			}
		}
	}
}

function Whipped:SetupOptions()
	local MasterFrame = {
		name = 'Main Options',
		type = 'group',
		args = {
			X = {
					name = 'X',
					order = 1,
					type = 'range',
					min = 0,
					max = ScreenWidth,
					step = .1,
					set = function(info, input) self.db.global.X = input; Whipped:UpdateMasterFrame() end,
					get = function(info) return self.db.global.X end
			},
			Y = {
				name = 'Y',
				order = 2,
				type = 'range',
				min = 0,
				max = ScreenHeight,
				step = .1,
				set = function(info, input) self.db.global.Y = input; Whipped:UpdateMasterFrame() end,
				get = function(info) return self.db.global.Y end
			},
			PaddingX = {
				name = 'Padding Horizontal',
				order = 4,
				type = 'range',
				min = 0,
				max = 200,
				softMin = 0,
				softMax = 100,
				step = .1,
				set = function(info, input) self.db.global.PaddingX = input; Whipped:UpdateAllFrames() end,
				get = function(info) return self.db.global.PaddingX end
			},
			PaddingY = {
				name = 'Padding Vertical',
				order = 5,
				type = 'range',
				min = 0,
				max = 200,
				softMin = 0,
				softMax = 100,
				step = .1,
				set = function(info, input) self.db.global.PaddingY = input; Whipped:UpdateAllFrames() end,
				get = function(info) return self.db.global.PaddingY end
			},
			Anchor = {
				name = 'Anchor',
				order = 6,
				type = 'select',
				values = Whipped.anchors,
				style = 'dropdown',
				set = function(info, input) self.db.global.Anchor = input; Whipped:UpdateAllFrames() end,
				get = function(info) return self.db.global.Anchor end
			},
			Strata = {
				name = 'Strata',
				order = 7,
				type = 'select',
				values = Whipped.strata,
				style = 'dropdown',
				set = function(info, input) self.db.global.Strata = input; Whipped.MasterFrame:SetFrameStrata(Whipped.strata[input]) end,
				get = function(info) return self.db.global.Strata end
			},
			Locked = {
				name = 'Locked',
				type = 'toggle',
				order = 8,
				set =
					function(info, input)
						self.db.global.Locked = input;
						Whipped.MasterFrame:EnableMouse(not input);
						Whipped.MasterFrame:SetMovable(not input);
					end,
				get =
					function(info)
						return self.db.global.Locked
					end
			},
			Show = {
				name = 'Show',
				type = 'toggle',
				order = 9,
				set =
					function(info, input)
						self.db.global.Show = input;
						if input == true then
							Whipped.MasterFrame:Show()
						else
							Whipped.MasterFrame:Hide()
						end
					end,
				get =
					function(info)
						return self.db.global.Show
					end
			},
			ShowOOC = {
				name = 'Show out of combat',
				type = 'toggle',
				order = 10,
				set =
					function(info, input)
						self.db.global.ShowOOC = input;
						if input and self.db.global.Show and GetSpecialization() == 2 then
							Whipped.MasterFrame:Show()
						elseif not InCombatLockdown() then
							Whipped.MasterFrame:Hide()
						end
					end,
				get =
					function(info)
						return self.db.global.ShowOOC
					end
			}
		}
	}
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Whipped", MasterFrame) -- AppName, Options, SlashCMD
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Whipped") -- AppName, Name(Defaults to AppName), Parent
	
	local Icons = {
		name = 'Icons',
		type = 'group',
		args = {
			Artefact = {
				name = "Artefact",
				type = "header",
				order = 1,
			},
			Artefact_Size = {
				name = 'Icon Size',
				order = 2,
				type = 'range',
				min = 1,
				max = 100,
				step = .1,
				set = function(info, input) self.db.global.Icons.Artefact_Size = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Artefact_Size end
			},
			Artefact_X = {
				name = 'X',
				order = 3,
				type = 'range',
				min = -ScreenWidth,
				max = ScreenWidth,
				step = .1,
				set = function(info, input) self.db.global.Icons.Artefact_X = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Artefact_X end
			},
			Artefact_Y = {
				name = 'Y',
				order = 4,
				type = 'range',
				min = -ScreenHeight,
				max = ScreenHeight,
				step = .1,
				set = function(info, input) self.db.global.Icons.Artefact_Y = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Artefact_Y end
			},
			Artefact_AnchorFrame = {
				name = 'Anchor Frame',
				order = 5,
				type = 'select',
				values = {"Addon Frame", "Doom Icon", "Implosion Icon", "Demonbolt Icon", "None"},
				style = 'dropdown',
				set = function(info, input) self.db.global.Icons.Artefact_AnchorFrame = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Artefact_AnchorFrame end
			},
			Artefact_AnchorPoint = {
				name = 'Anchor Point',
				order = 6,
				type = 'select',
				values = Whipped.anchors,
				style = 'dropdown',
				set = function(info, input) self.db.global.Icons.Artefact_AnchorPoint = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Artefact_AnchorPoint end
			},
			Artefact_NumberAnchorPoint = {
				name = 'Number Anchor Point',
				order = 7,
				type = 'select',
				values = Whipped.anchors,
				style = 'dropdown',
				set = function(info, input) self.db.global.Icons.Artefact_NumberAnchorPoint = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Artefact_NumberAnchorPoint end
			},
			Demonbolt = {
				name = "Demonbolt",
				type = "header",
				order = 10,
			},
			Demonbolt_Size = {
				name = 'Icon Size',
				order = 11,
				type = 'range',
				min = 1,
				max = 100,
				step = .1,
				set = function(info, input) self.db.global.Icons.Demonbolt_Size = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Demonbolt_Size end
			},
			Demonbolt_X = {
				name = 'X',
				order = 12,
				type = 'range',
				min = -ScreenWidth,
				max = ScreenWidth,
				step = .1,
				set = function(info, input) self.db.global.Icons.Demonbolt_X = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Demonbolt_X end
			},
			Demonbolt_Y = {
				name = 'Y',
				order = 13,
				type = 'range',
				min = -ScreenHeight,
				max = ScreenHeight,
				step = .1,
				set = function(info, input) self.db.global.Icons.Demonbolt_Y = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Demonbolt_Y end
			},
			Demonbolt_AnchorFrame = {
				name = 'Anchor Frame',
				order = 14,
				type = 'select',
				values = {"Addon Frame", "Artefact Icon", "Doom Icon", "Implosion Icon",  "None"},
				style = 'dropdown',
				set = function(info, input) self.db.global.Icons.Demonbolt_AnchorFrame = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Demonbolt_AnchorFrame end
			},
			Demonbolt_AnchorPoint = {
				name = 'Anchor Point',
				order = 15,
				type = 'select',
				values = Whipped.anchors,
				style = 'dropdown',
				set = function(info, input) self.db.global.Icons.Demonbolt_AnchorPoint = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Demonbolt_AnchorPoint end
			},
			Demonbolt_NumberAnchorPoint = {
				name = 'Number Anchor Point',
				order = 16,
				type = 'select',
				values = Whipped.anchors,
				style = 'dropdown',
				set = function(info, input) self.db.global.Icons.Demonbolt_NumberAnchorPoint = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Demonbolt_NumberAnchorPoint end
			},
			Implosion = {
				name = "Implosion",
				type = "header",
				order = 20,
			},
			Implosion_Size = {
				name = 'Icon Size',
				order = 21,
				type = 'range',
				min = 1,
				max = 100,
				step = .1,
				set = function(info, input) self.db.global.Icons.Implosion_Size = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Implosion_Size end
			},
			Implosion_X = {
				name = 'X',
				order = 22,
				type = 'range',
				min = -ScreenWidth,
				max = ScreenWidth,
				step = .1,
				set = function(info, input) self.db.global.Icons.Implosion_X = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Implosion_X end
			},
			Implosion_Y = {
				name = 'Y',
				order = 23,
				type = 'range',
				min = -ScreenHeight,
				max = ScreenHeight,
				step = .1,
				set = function(info, input) self.db.global.Icons.Implosion_Y = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Implosion_Y end
			},
			Implosion_AnchorFrame = {
				name = 'Anchor Frame',
				order = 24,
				type = 'select',
				values = {"Addon Frame", "Artefact Icon", "Doom Icon", "Demonbolt Icon", "None"},
				style = 'dropdown',
				set = function(info, input) self.db.global.Icons.Implosion_AnchorFrame = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Implosion_AnchorFrame end
			},
			Implosion_AnchorPoint = {
				name = 'Anchor Point',
				order = 25,
				type = 'select',
				values = Whipped.anchors,
				style = 'dropdown',
				set = function(info, input) self.db.global.Icons.Implosion_AnchorPoint = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Implosion_AnchorPoint end
			},
			Implosion_NumberAnchorPoint = {
				name = 'Number Anchor Point',
				order = 26,
				type = 'select',
				values = Whipped.anchors,
				style = 'dropdown',
				set = function(info, input) self.db.global.Icons.Implosion_NumberAnchorPoint = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Implosion_NumberAnchorPoint end
			},
			Doom = {
				name = "Doom",
				type = "header",
				order = 30,
			},
			Doom_Size = {
				name = 'Icon Size',
				order = 31,
				type = 'range',
				min = 1,
				max = 100,
				step = .1,
				set = function(info, input) self.db.global.Icons.Doom_Size = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Doom_Size end
			},
			Doom_X = {
				name = 'X',
				order = 32,
				type = 'range',
				min = -ScreenWidth,
				max = ScreenWidth,
				step = .1,
				set = function(info, input) self.db.global.Icons.Doom_X = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Doom_X end
			},
			Doom_Y = {
				name = 'Y',
				order = 33,
				type = 'range',
				min = -ScreenHeight,
				max = ScreenHeight,
				step = .1,
				set = function(info, input) self.db.global.Icons.Doom_Y = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Doom_Y end
			},
			Doom_AnchorFrame = {
				name = 'Anchor Frame',
				order = 34,
				type = 'select',
				values = {"Addon Frame", "Artefact Icon", "Implosion Icon", "Demonbolt Icon", "None"},
				style = 'dropdown',
				set = function(info, input) self.db.global.Icons.Doom_AnchorFrame = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Doom_AnchorFrame end
			},
			Doom_AnchorPoint = {
				name = 'Anchor Point',
				order = 35,
				type = 'select',
				values = Whipped.anchors,
				style = 'dropdown',
				set = function(info, input) self.db.global.Icons.Doom_AnchorPoint = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Doom_AnchorPoint end
			},
			Doom_NumberAnchorPoint = {
				name = 'Number Anchor Point',
				order = 36,
				type = 'select',
				values = Whipped.anchors,
				style = 'dropdown',
				set = function(info, input) self.db.global.Icons.Doom_NumberAnchorPoint = input; Whipped:UpdateIcons() end,
				get = function(info) return self.db.global.Icons.Doom_NumberAnchorPoint end
			},
			DoomPartials = {
				name = 'Partial Ticks',
				desc = 'When enabled, shows both full and partial Doom ticks from all targets. Only show the full ticks when disabled.',
				type = 'toggle',
				order = 37,
				set = function(info, input) self.db.global.Icons.DoomPartials = input end,
				get = function(info) return self.db.global.Icons.DoomPartials end
			}
		}
	}
	Whipped:AddCategory("Icons", Icons)
	
	Whipped:SoulShards_SetupOptions()
	Whipped:Imps_SetupOptions()
	Whipped:Dreadstalkers_SetupOptions()
	Whipped:Cooldown_SetupOptions()
	Whipped:Grimoire_SetupOptions()
	Whipped:Darkglare_SetupOptions()
end

function Whipped:AddCategory(name, option)
	if not self.options then
		self.options = {
			name = "Whipped",
			type = 'group',
			args = {}
		}
		self.options.frames = {}
	end
	
	self.options.args[name] = option
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Whipped/".. name, self.options.args[name], "Whipped/"..name)
	LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Whipped/" .. name, option.name, "Whipped")
end

Whipped:RegisterChatCommand("Whipped",
	function()
		InterfaceOptionsFrame_OpenToCategory("Whipped")
		InterfaceOptionsFrame_OpenToCategory("Whipped")
	end)
-- Scripts and Events
function Whipped:COMBAT_LOG_EVENT_UNFILTERED(_, ...)
	local event = select(2, ...)
	if strfind(event,"_DAMAGE") then
		Whipped:Imps_CLE(...)
	elseif event == "SPELL_CAST_SUCCESS" then
		if select(12,...) == 193396 and bit.band(select(6,...), COMBATLOG_OBJECT_AFFILIATION_MINE) > 0 then -- Demonic Empowerment
			ActionButton_ShowOverlayGlow(Frame_MainDemon_Icon)
			DE = GetTime() + 12
			Demons.BaseDemon.DE = DE_DamageIncrease
			Demons.Dreadstalkers.DE = DE_DamageIncrease
			Demons.CooldownDemon.DE = DE_DamageIncrease
			Demons.GrimoireDemon.DE = DE_DamageIncrease
			Demons.Darkglare.DE = DE_DamageIncrease
			for i=1,Whipped.ImpFrameListSize do
				Demons.Imps.HoG.Wave[i].DE = DE_DamageIncrease
			end
			Demons.Imps.Dreadstalkers.DE = DE_DamageIncrease
			for k,v in pairs(Demons.Imps.Doom.Wave) do
				v.DE = DE_DamageIncrease
			end
			FontString_Artefact:SetText(Whipped:ArtefactDamage())
			Whipped:Imps_CLE(...)
			Whipped:Dreadstalkers_CLE(...)
			Whipped:Cooldown_CLE(...)
			Whipped:Grimoire_CLE(...)
			Whipped:Darkglare_CLE(...)
		end
	elseif event == "SPELL_AURA_REFRESH" then
		if select(12,...) == 603 and bit.band(select(6,...), COMBATLOG_OBJECT_AFFILIATION_MINE) > 0 then -- Doom
			local Time = GetTime()
			local TickTime = Time + mfloor(Whipped:GetDoomDuration()*1300)/1000
			local Doom = DOOM[select(8,...)]
			if Doom[2][1] == 0 or Doom[1][1] - Time > Whipped:GetDoomDuration() * .3 then
				if Doom[1][1] - Time <= Whipped:GetDoomDuration() * .3 then -- Checks if its a full tick
					TickTime = TickTime - (Whipped:GetDoomDuration() * .3 - (Doom[1][1] - Time))
					Doom[2][1] = TickTime
					Doom[2][2] = true -- Full Tick
					if DoomTimer == 0 then DoomTimer = TickTime end
				else
					Doom[2][1] = TickTime
					Doom[2][2] = false -- Partial Tick
				end
			elseif Doom[1][1] - Time <= Whipped:GetDoomDuration() * .3 then
				Doom[2][1] = TickTime - (Whipped:GetDoomDuration() * .3 - (Doom[1][1] - Time))
				Doom[2][2] = true
				Doom[3][1] = TickTime
				Doom[3][2] = false
			end
		end
	elseif event == "SPELL_AURA_APPLIED" then
		if select(12,...) == 603 and bit.band(select(6,...), COMBATLOG_OBJECT_AFFILIATION_MINE) > 0 then -- Doom
			local TickTime = GetTime() + mfloor(Whipped:GetDoomDuration() * 1000) / 1000
			DOOM[select(8,...)] = {[1] = {TickTime, true}, [2] = {0, false}, [3] = {0, false}}
			if DoomTimer == 0 then DoomTimer = TickTime end
		end
	elseif event == "SPELL_AURA_REMOVED" then
		if bit.band(select(6,...), COMBATLOG_OBJECT_AFFILIATION_MINE) > 0 then
			if select(12,...) == 193396 then -- Demonic Empowerment
				ActionButton_HideOverlayGlow(Frame_MainDemon_Icon)
				Whipped:Cooldown_CLE(...)
				Whipped:Grimoire_CLE(...)
			elseif select(12,...) == 603 then -- Doom
				DOOM[select(8,...)] = nil
				DoomTimer = 0
			end
		end
		Whipped:Dreadstalkers_CLE(...)
	elseif event == "SPELL_SUMMON" then
		if bit.band(select(6,...), COMBATLOG_OBJECT_AFFILIATION_MINE) > 0 then
			local SpellID = select(12, ...)
			if SpellID == 30146 or SpellID == 157757 or SpellID == 157898 then -- Felguard, Doomguard, Infernal; Wrathguard still needs adding, ignoring all lesser base pets
				UNIT_PET_UPDATE = false
				Demons.BaseDemon.Alive = 1
				Demons.BaseDemon.DE = 1
				Demons.BaseDemon.Type = SpellID
				Demons.BaseDemon.GUID = select(8, ...)
				Demons.BaseDemon.Name = select(9, ...)
			end
		end
		Whipped:Dreadstalkers_CLE(...)
		Whipped:Imps_CLE(...)
		Whipped:Cooldown_CLE(...)
		Whipped:Grimoire_CLE(...)
		Whipped:Darkglare_CLE(...)
	elseif event == "UNIT_DIED" then
		local unitGUID = select(8,...)
		if DOOM[unitGUID] ~= nil then DOOM[unitGUID] = nil end
		if unitGUID == Demons.BaseDemon.GUID then -- Felguard, Doomguard, Infernal; Wrathguard still needs adding
			UNIT_PET_UPDATE = nil
			Demons.BaseDemon.Alive = 0
			Demons.BaseDemon.GUID = 0
		end
		Whipped:Dreadstalkers_CLE(...)
		--Whipped:Imps_CLE(...) -- Little guys don't have a UNIT_DIED event
		Whipped:Cooldown_CLE(...)
		Whipped:Grimoire_CLE(...)
		Whipped:Darkglare_CLE(...)
	elseif event == "SPELL_AURA_APPLIED" then
		Whipped:Dreadstalkers_CLE(...)
	elseif event == "SPELL_AURA_REMOVED" then
		Whipped:Dreadstalkers_CLE(...)
	elseif event == "SPELL_INSTAKILL" then
		Whipped:Imps_CLE(...)
	end
end

function Whipped:PLAYER_TALENT_UPDATE()
	if GetSpecialization() == 2 then
		local id,_,_,b = GetTalentInfo(7,2,1)
		if id == 22479 and b then
			Frame_Demonbolt_Icon:Show()
		else
			Frame_Demonbolt_Icon:Hide()
		end
		local id,_,_,b = GetTalentInfo(2,3,1)
		if id == 22089 and b then
			Frame_Implosion_Icon:Show()
		else
			Frame_Implosion_Icon:Hide()
		end
		Whipped:Grimoire_UpdateTalents()
		Whipped:Darkglare_UpdateTalents()
		
		Whipped:UpdateAllFrames()
	end
end

function Whipped:ACTIVE_TALENT_GROUP_CHANGED()
	if GetSpecialization() == 2 then
		if self.db.global.ShowOOC == false or self.db.global.Show == false then
			Whipped.MasterFrame:Hide()
		else
			Whipped.MasterFrame:Show()
		end
	else
		Whipped.MasterFrame:Hide()
	end
end

function Whipped:UNIT_PET(_, unitID)
	if unitID == "player" and UNIT_PET_UPDATE ~= nil then -- nil is when the pet died
		if UNIT_PET_UPDATE and (not UnitIsDead("pet") or UnitExists("pet")) then -- Pet is alive
			UNIT_PET_UPDATE = false
			Demons.BaseDemon.Alive = 1
			Demons.BaseDemon.GUID = UnitGUID("pet")
			local demon = UnitCreatureFamily("pet")
			if demon == "Felguard" then
				Demons.BaseDemon.Type = 30146
			--elseif demon == "Wrathguard" == 112870 then
			--	Demons.BaseDemon.Type = 112870
			elseif demon == "Doomguard" then
				Demons.BaseDemon.Type = 157757
			elseif demon == "Infernal" then
				Demons.BaseDemon.Type = 157898
			end
		elseif not UNIT_PET_UPDATE and (UnitIsDead("pet") or not UnitExists("pet")) then -- Pet is dismissed or pulls a Houdini
			UNIT_PET_UPDATE = true
			Demons.BaseDemon.Alive = 0
			Demons.BaseDemon.GUID = 0
		end
	end
end

function Whipped:UNIT_MAXHEALTH(_, unitID)
	if unitID == "player" then
		FontString_Artefact:SetText(Whipped:ArtefactDamage())
	end
end

function Whipped:PLAYER_REGEN_DISABLED()
	if self.db.global.Show and GetSpecialization() == 2 then
		Whipped.MasterFrame:Show()
	end
end

function Whipped:PLAYER_REGEN_ENABLED()
	if self.db.global.ShowOOC == false or self.db.global.Show == false then
		Whipped.MasterFrame:Hide()
	end
end

function Whipped:LOADING_SCREEN_DISABLED()
	if self.db.global.Show == true and GetSpecialization() == 2 then
		if self.db.global.ShowOOC then
			self.MasterFrame:Show()
		elseif not InCombatLockdown() then
			self.MasterFrame:Hide()
		end
	else
		Whipped.MasterFrame:Hide()
	end
end

Whipped:RegisterEvent("PLAYER_ENTERING_WORLD",
	function()
		Whipped:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		Whipped:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
		Whipped:RegisterEvent("PLAYER_TALENT_UPDATE")
		Whipped:RegisterEvent("UNIT_PET")
		Whipped:RegisterEvent("UNIT_MAXHEALTH")
		Whipped:RegisterEvent("PLAYER_REGEN_DISABLED")
		Whipped:RegisterEvent("PLAYER_REGEN_ENABLED")
		Whipped:RegisterEvent("LOADING_SCREEN_DISABLED")
		Whipped:ACTIVE_TALENT_GROUP_CHANGED()
	end)
	
--Functions
function Whipped:OnInitialize()
	self:SetupOptions() -- Create all the options menus
	self.db = LibStub("AceDB-3.0"):New("WhippedDB", defaults, true)

	-- MasterFrame
	self.MasterFrame.texture = self.MasterFrame:CreateTexture(nil, "BACKGROUND")
	self.MasterFrame.texture:SetAllPoints(true)
	self.MasterFrame.texture:SetTexture(1,1,1,0)
	self.MasterFrame.texture:SetVertexColor(1,0,0,.5)
	self.MasterFrame:SetMovable(not self.db.global.Locked)
	self.MasterFrame:EnableMouse(not self.db.global.Locked)
	self.MasterFrame:RegisterForDrag("LeftButton")
	self.MasterFrame:SetScript("OnDragStart", self.MasterFrame.StartMoving)
	self.MasterFrame:SetScript("OnDragStop",
		function()
			Whipped.MasterFrame:StopMovingOrSizing()
			self.db.global.X = mfloor(Whipped.MasterFrame:GetLeft() + .5)
			self.db.global.Y = mfloor(Whipped.MasterFrame:GetBottom() + .5)
		end)
	self.MasterFrame:SetScript("OnUpdate", Whipped_OnUpdate)
	self.MasterFrame:SetFrameStrata(Whipped.strata[self.db.global.Strata] or "BACKGROUND")

	-- Artefact Icon
	Frame_Artefact_Icon.texture = Frame_Artefact_Icon:CreateTexture(nil, "BACKGROUND")
	Frame_Artefact_Icon.texture:SetTexture("Interface\\Icons\\Inv_offhand_1h_artifactskulloferedar_d_01")
	Frame_Artefact_Icon.texture:SetAllPoints(true)
	
	-- Demonbolt Icon
	Frame_Demonbolt_Icon.texture = Frame_Demonbolt_Icon:CreateTexture(nil, "BACKGROUND")
	Frame_Demonbolt_Icon.texture:SetTexture("Interface\\Icons\\spell_warlock_demonbolt")
	Frame_Demonbolt_Icon.texture:SetAllPoints(true)
	
	-- Doom Icon
	Frame_Doom_Icon.texture = Frame_Doom_Icon:CreateTexture(nil, "BACKGROUND")
	Frame_Doom_Icon.texture:SetTexture("Interface\\Icons\\spell_shadow_auraofdarkness")
	Frame_Doom_Icon.texture:SetAllPoints(true)
	
	-- Implosion Icon
	Frame_Implosion_Icon.texture = Frame_Implosion_Icon:CreateTexture(nil, "BACKGROUND")
	Frame_Implosion_Icon.texture:SetTexture("Interface\\Icons\\spell_shadow_shadowandflame")
	Frame_Implosion_Icon.texture:SetAllPoints(true)
	
	-- Demon Icon
	Frame_MainDemon_Icon.texture = Frame_MainDemon_Icon:CreateTexture(nil, "BACKGROUND")
	Frame_MainDemon_Icon.texture:SetTexture("Interface\\Icons\\spell_shadow_summonfelguard")
	Frame_MainDemon_Icon.texture:SetAllPoints(true)
	
	-- Fontstring Artefact
	FontString_Artefact:SetFont(WHIPPED_CHAT_FONT, self.db.global.Icons.Artefact_Size / 2)
	FontString_Artefact:SetTextColor(1,1,1,1)
	FontString_Artefact:SetText(self:ArtefactDamage())
	
	-- Fontstring Demonbolt
	FontString_Demonbolt:SetPoint("CENTER")
	FontString_Demonbolt:SetFont(WHIPPED_CHAT_FONT, self.db.global.Icons.Demonbolt_Size / 2)
	FontString_Demonbolt:SetTextColor(1,1,1,1)
	
	-- Fontstring Doom
	FontString_Doom:SetPoint("CENTER")
	FontString_Doom:SetFont(WHIPPED_CHAT_FONT, self.db.global.Icons.Doom_Size / 2)
	FontString_Doom:SetTextColor(1,1,1,1)
	FontString_Doom:SetText(0)
	
	-- Fontstring Implosion
	FontString_Implosion:SetPoint("CENTER")
	FontString_Implosion:SetFont(WHIPPED_CHAT_FONT, self.db.global.Icons.Implosion_Size / 2)
	FontString_Implosion:SetTextColor(1,1,1,1)
	
	self:PLAYER_TALENT_UPDATE()
	
	self:SoulShards_OnLoad()
	self:Dreadstalkers_OnLoad()
	self:Imps_OnLoad()
	self:Cooldown_OnLoad()
	self:Grimoire_OnLoad()
	self:Darkglare_OnLoad()

	self:UpdateAllFrames()
end

function Whipped:OnEnable() -- Called when the addon is enabled
end

function Whipped:OnDisable() -- Called when the addon is disabled
end

function Whipped_OnUpdate(self, elapsed)
	TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed
	
	while (TimeSinceLastUpdate > Whipped_UpdateInterval) do
		if UpdateFonts ~= Demons.ActiveDemons() then -- Only run when your amount of demons changes
			FontString_Artefact:SetText(Whipped:ArtefactDamage())
			FontString_Demonbolt:SetText(Demons.ActiveDemons())
			FontString_Implosion:SetText(Demons.Imps.Alive())
			UpdateFonts = Demons.ActiveDemons()
		end
		local Time = GetTime()
		
		if DE > 0 then -- Demonic Empowerment
			if DE - Time < 0 then
				DE = 0
				Demons.BaseDemon.DE = 1
				Demons.Dreadstalkers.DE = 1
				Demons.CooldownDemon.DE = 1
				Demons.GrimoireDemon.DE = 1
				Demons.Darkglare.DE = 1
				for i=1,Whipped.ImpFrameListSize do
					Demons.Imps.HoG.Wave[i].DE = 1
				end
				Demons.Imps.Dreadstalkers.DE = 1
				for k,v in pairs(Demons.Imps.Doom.Wave) do
					v.DE = 1
				end
				FontString_Artefact:SetText(Whipped:ArtefactDamage())
			end
		end

		local DT = DoomTimer - Time
		if DT <= 0 then -- Tick
			DoomTimer = 0
			DT = 0
			local SHOW_DOOM_PARTIALS = Whipped.db.global.Icons.DoomPartials 
			for k,v in pairs(DOOM) do
				if v[1][1] < Time then -- Already ticked
					v[1] = v[2]
					v[2] = v[3]
					v[3] = {0, false}
				end
				if DoomTimer > v[1][1] or DoomTimer == 0 then
					if SHOW_DOOM_PARTIALS then
						DoomTimer = v[1][1]
					else
						if v[1][2] == true then
							DoomTimer = v[1][1]
						end
					end
				end
			end
		end
		FontString_Doom:SetText((mfloor(DT * 10) / 10))
		
		Whipped:SoulShards_OnUpdate()
		Whipped:Dreadstalkers_OnUpdate()
		Whipped:Imps_OnUpdate()
		Whipped:Cooldown_OnUpdate()
		Whipped:Grimoire_OnUpdate()
		Whipped:Darkglare_OnUpdate()
		TimeSinceLastUpdate = 0
	end
end

function Whipped:UpdateMasterFrame()
	-- Updates MasterFrame
	local MasterFrame = Whipped.db.global
	local anchorID = Whipped.db.global.Anchor
	local anchor, Oanchor = Whipped.anchors[anchorID], Whipped:OppositeAnchor(anchorID)
	local SoulShards = MasterFrame.SoulShards
	local Imps = MasterFrame.Imps
	local Dreadstalkers = MasterFrame.Dreadstalkers
	local Cooldown = MasterFrame.Cooldown
	local Grimoire = MasterFrame.Grimoire
	local Darkglare = MasterFrame.Darkglare

	local add = 0
	if SoulShards.Show then
		if anchorID == 1 or anchorID == 2 then
			add = add + SoulShards.Height + SoulShards.Padding
		else
			add = add + SoulShards.Width + SoulShards.Padding
		end
	end
	if Imps.Show then
		add = add + Imps.Thickness + Imps.Padding * 2
	end
	if Dreadstalkers.Show then
		add = add + Dreadstalkers.Thickness + Dreadstalkers.Padding * 2
	end
	if Cooldown.Show then
		add = add + Cooldown.Thickness + Cooldown.Padding * 2
	end
	if Demons.GrimoireDemon.Talented and Grimoire.Show then
		add = add + Grimoire.Thickness + Grimoire.Padding * 2
	end
	if Demons.Darkglare.Talented and Darkglare.Show then
		add = add + Darkglare.Thickness + Darkglare.Padding * 2
	end
	
	if anchorID == 1 or anchorID == 2 then -- Left or Right
		Whipped.MasterFrame:SetWidth((SoulShards.Width * 5 + SoulShards.Padding * 4 + MasterFrame.PaddingX * 2))
		Whipped.MasterFrame:SetHeight(MasterFrame.PaddingY * 2 + add)
	else -- Top or Bottom
		Whipped.MasterFrame:SetWidth(MasterFrame.PaddingX * 2 + add)
		Whipped.MasterFrame:SetHeight(SoulShards.Height * 5 + SoulShards.Padding * 4 + MasterFrame.PaddingY * 2)
	end
	Frame_MainDemon_Icon:ClearAllPoints()
	
	local ImplosionAnchor
	if Frame_Demonbolt_Icon:IsShown() then ImplosionAnchor = Frame_Demonbolt_Icon else ImplosionAnchor = Frame_Doom_Icon end

	if anchorID == 1 then
		Frame_MainDemon_Icon:SetWidth(self.db.global.SoulShards.Height)
		Frame_MainDemon_Icon:SetHeight(self.db.global.SoulShards.Height)
		Frame_MainDemon_Icon:SetPoint("TOPLEFT", Whipped.MasterFrame, "TOPRIGHT", 0, -MasterFrame.PaddingY)
	elseif anchorID == 2 then
		Frame_MainDemon_Icon:SetWidth(self.db.global.SoulShards.Height)
		Frame_MainDemon_Icon:SetHeight(self.db.global.SoulShards.Height)
		Frame_MainDemon_Icon:SetPoint("TOPRIGHT", Whipped.MasterFrame, "TOPLEFT", 0, -MasterFrame.PaddingY)
	elseif anchorID == 3 then
		Frame_MainDemon_Icon:SetWidth(self.db.global.SoulShards.Width)
		Frame_MainDemon_Icon:SetHeight(self.db.global.SoulShards.Width)
		Frame_MainDemon_Icon:SetPoint("TOPLEFT", Whipped.MasterFrame, "BOTTOMLEFT", MasterFrame.PaddingX, 0)
	elseif anchorID == 4 then
		Frame_MainDemon_Icon:SetWidth(self.db.global.SoulShards.Width)
		Frame_MainDemon_Icon:SetHeight(self.db.global.SoulShards.Width)
		Frame_MainDemon_Icon:SetPoint("BOTTOMLEFT", Whipped.MasterFrame, "TOPLEFT", MasterFrame.PaddingX, 0)
	end
	
	if SoulShards.Show then
		Frame_MainDemon_Icon:Show()
	else
		Frame_MainDemon_Icon:Hide()
	end
	
	Whipped.MasterFrame:ClearAllPoints()
	Whipped.MasterFrame:SetPoint("BOTTOMLEFT", MasterFrame.X, MasterFrame.Y)
end

function Whipped:UpdateIcons()
	local Icons, anchorPoint, anchorFrame, FontAnchor, offsetX, offsetY = self.db.global.Icons
	-- Artefact
	anchorPoint = Icons.Artefact_AnchorPoint
	anchorFrame = Icons.Artefact_AnchorFrame
	FontAnchor = Icons.Artefact_NumberAnchorPoint
	if anchorPoint == 1 then offsetX = -2; offsetY = 0 elseif anchorPoint == 2 then offsetX = 2; offsetY = 0
		elseif anchorPoint == 3 then offsetX = 0; offsetY = 2 else offsetX = 0; offsetY = -2 end
	if anchorFrame == 1 then anchorFrame = Whipped.MasterFrame elseif anchorFrame == 2 then anchorFrame = Frame_Doom_Icon
		elseif anchorFrame == 3 then anchorFrame = Frame_Implosion_Icon elseif anchorFrame == 4 then anchorFrame = Frame_Demonbolt_Icon
		else anchorFrame = UIParent end
	if not Whipped:FrameDependence(Frame_Artefact_Icon, anchorFrame) then return end
	Frame_Artefact_Icon:SetWidth(Icons.Artefact_Size)
	Frame_Artefact_Icon:SetHeight(Icons.Artefact_Size)
	Frame_Artefact_Icon:ClearAllPoints()
	FontString_Artefact:ClearAllPoints()
	Frame_Artefact_Icon:SetPoint(Whipped:OppositeAnchor(anchorPoint), anchorFrame, Whipped.anchors[anchorPoint],
		Icons.Artefact_X, Icons.Artefact_Y)
	FontString_Artefact:SetPoint(Whipped:OppositeAnchor(FontAnchor),Frame_Artefact_Icon, Whipped.anchors[FontAnchor],
		offsetX, offsetY)
	FontString_Artefact:SetFont(WHIPPED_CHAT_FONT, Icons.Artefact_Size / 2)
	
	-- Demonbolt
	anchorPoint = Icons.Demonbolt_AnchorPoint
	anchorFrame = Icons.Demonbolt_AnchorFrame
	FontAnchor = Icons.Demonbolt_NumberAnchorPoint
	if anchorPoint == 1 then offsetX = -2; offsetY = 0 elseif anchorPoint == 2 then offsetX = 2; offsetY = 0
		elseif anchorPoint == 3 then offsetX = 0; offsetY = 2 else offsetX = 0; offsetY = -2 end
	if anchorFrame == 1 then anchorFrame = Whipped.MasterFrame elseif anchorFrame == 2 then anchorFrame = Frame_Artefact_Icon
		elseif anchorFrame == 3 then anchorFrame = Frame_Doom_Icon elseif anchorFrame == 4 then anchorFrame = Frame_Implosion_Icon
		else anchorFrame = UIParent end
	if not Whipped:FrameDependence(Frame_Demonbolt_Icon, anchorFrame) then return end
	Frame_Demonbolt_Icon:SetWidth(Icons.Demonbolt_Size)
	Frame_Demonbolt_Icon:SetHeight(Icons.Demonbolt_Size)
	Frame_Demonbolt_Icon:ClearAllPoints()
	FontString_Demonbolt:ClearAllPoints()
	Frame_Demonbolt_Icon:SetPoint(Whipped:OppositeAnchor(anchorPoint), anchorFrame, Whipped.anchors[anchorPoint],
		Icons.Demonbolt_X, Icons.Demonbolt_Y)
	FontString_Demonbolt:SetPoint(Whipped:OppositeAnchor(FontAnchor),Frame_Demonbolt_Icon, Whipped.anchors[FontAnchor],
		offsetX, offsetY)
	FontString_Demonbolt:SetFont(WHIPPED_CHAT_FONT, Icons.Demonbolt_Size / 2)
	
	-- Implosion
	anchorPoint = Icons.Implosion_AnchorPoint
	anchorFrame = Icons.Implosion_AnchorFrame
	FontAnchor = Icons.Implosion_NumberAnchorPoint
	if anchorPoint == 1 then offsetX = -2; offsetY = 0 elseif anchorPoint == 2 then offsetX = 2; offsetY = 0
		elseif anchorPoint == 3 then offsetX = 0; offsetY = 2 else offsetX = 0; offsetY = -2 end
	if anchorFrame == 1 then anchorFrame = Whipped.MasterFrame elseif anchorFrame == 2 then anchorFrame = Frame_Artefact_Icon
		elseif anchorFrame == 3 then anchorFrame = Frame_Doom_Icon elseif anchorFrame == 4 then anchorFrame = Frame_Demonbolt_Icon
		else anchorFrame = UIParent end
	if not Whipped:FrameDependence(Frame_Implosion_Icon, anchorFrame) then return end
	Frame_Implosion_Icon:SetWidth(Icons.Implosion_Size)
	Frame_Implosion_Icon:SetHeight(Icons.Implosion_Size)
	Frame_Implosion_Icon:ClearAllPoints()
	FontString_Implosion:ClearAllPoints()
	Frame_Implosion_Icon:SetPoint(Whipped:OppositeAnchor(anchorPoint), anchorFrame, Whipped.anchors[anchorPoint],
		Icons.Implosion_X, Icons.Implosion_Y)
	FontString_Implosion:SetPoint(Whipped:OppositeAnchor(FontAnchor),Frame_Implosion_Icon, Whipped.anchors[FontAnchor],
		offsetX, offsetY)
	FontString_Implosion:SetFont(WHIPPED_CHAT_FONT, Icons.Implosion_Size / 2)
	
	-- Doom
	anchorPoint = Icons.Doom_AnchorPoint
	anchorFrame = Icons.Doom_AnchorFrame
	FontAnchor = Icons.Doom_NumberAnchorPoint
	if anchorPoint == 1 then offsetX = -2; offsetY = 0 elseif anchorPoint == 2 then offsetX = 2; offsetY = 0
		elseif anchorPoint == 3 then offsetX = 0; offsetY = 2 else offsetX = 0; offsetY = -2 end
	if anchorFrame == 1 then anchorFrame = Whipped.MasterFrame elseif anchorFrame == 2 then anchorFrame = Frame_Artefact_Icon
		elseif anchorFrame == 3 then anchorFrame = Frame_Implosion_Icon elseif anchorFrame == 4 then anchorFrame = Frame_Demonbolt_Icon
		else anchorFrame = UIParent end
	if not Whipped:FrameDependence(Frame_Doom_Icon, anchorFrame) then return end
	Frame_Doom_Icon:SetWidth(Icons.Doom_Size)
	Frame_Doom_Icon:SetHeight(Icons.Doom_Size)
	Frame_Doom_Icon:ClearAllPoints()
	FontString_Doom:ClearAllPoints()
	Frame_Doom_Icon:SetPoint(Whipped:OppositeAnchor(anchorPoint), anchorFrame, Whipped.anchors[anchorPoint],
		Icons.Doom_X, Icons.Doom_Y)
	FontString_Doom:SetPoint(Whipped:OppositeAnchor(FontAnchor),Frame_Doom_Icon, Whipped.anchors[FontAnchor],
		offsetX, offsetY)
	FontString_Doom:SetFont(WHIPPED_CHAT_FONT, Icons.Doom_Size / 2)
end

function Whipped:UpdateAllFrames()
	Whipped:UpdateMasterFrame()
	Whipped:UpdateIcons()
	Whipped:SoulShards_UpdateFrames()
	Whipped:Dreadstalkers_UpdateFrames()
	Whipped:Imps_UpdateFrames()
	Whipped:Cooldown_UpdateFrames()
	Whipped:Grimoire_UpdateFrames()
	Whipped:Darkglare_UpdateFrames()
end

function Whipped:OppositeAnchor(id)
	if id == 5 then return "CENTER" end
	if id % 2 == 0 then
		return Whipped.anchors[id-1]
	else
		return Whipped.anchors[id+1]
	end
end

function Whipped:ArtefactDamage()
	local d,dmg=Whipped.Demons,0
	b,c,g,e,d,i=d.BaseDemon,d.CooldownDemon,d.GrimoireDemon,d.Darkglare,d.Dreadstalkers,d.Imps
	return mfloor((b.Health()+c.Health()+g.Health()+e.Health()+d.Health()+i.Health())*.06)
end

function Whipped:GetDoomDuration()
	return mfloor(.5+1000*(20/(1+GetHaste()/100)))/1000
end

function Whipped:FrameDependence(src, dst)
	if dst == nil then return true end
	local i = 10
	while i > 0 do
		dst = select(2,dst:GetPoint(1))
		if dst == src then
			Whipped:Print("Please select a different anchor frame.")
			return false
		end
		i = i - 1
		if dst == nil then i = 0 end
	end
	return true
end

-- DEBUG
-- ChatFrame3:SetFont(WHIPPED_CHAT_FONT, select(2, ChatFrame3:GetFont()))
-- function Whipped:DEBUG(arg1, arg2, arg3, arg4)
	-- -- #1 Table to parse
	-- -- #2 How deep to go(nil if endless)
	-- -- #3 type to find(nil if none, "all" if any)
	-- -- #4 Used by recursion, do not use manually
	-- -- local function Spaces(s)
		-- local S = ""
		-- for c = 1, s do
			-- S = S.."|  "
		-- end
		-- return S
	-- end
	-- if type(arg1) ~= 'table' then Whipped:Print("Argument is not of type 'table'. Is type '"..type(arg1).."'"); return end
	-- if arg4 == nil then print("root") end
	-- local arg4 = arg4 or 1
	-- if arg4 > (arg2 or arg4 + 1) then return end -- arg4 + 1 is to parse the whole tree, no matter how deep
	
	-- for k,v in pairs(arg1) do
		-- if type(v) == arg3 or type(v) == 'table' or 'all' == arg3 then
			-- if 'table' == type(v) then
				-- print(Spaces(arg4)..tostring(k).." - "..type(v))
				-- self:DEBUG(v, arg2, arg3, arg4 + 1)
			-- else
				-- print(Spaces(arg4)..tostring(k).." - "..type(v))
			-- end
		-- end
	-- end
-- end